/*
This software has been released under the MIT license:

  Copyright (c) 2009 Lewis R Cunningham

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in
  all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  THE SOFTWARE.
*/ 
CREATE OR REPLACE VIEW routines
AS
SELECT * FROM (
    SELECT SYS_CONTEXT('userenv', 'DB_NAME') ROUTINE_CATALOG,
           SYS_CONTEXT('userenv', 'DB_NAME') SPECIFIC_CATALOG,
           ap.owner specific_SCHEMA,
           ap.owner routine_SCHEMA,
           decode( ap.procedure_name, null, ap.object_name || ap.procedure_name, ap.procedure_name ) specific_name, 
           decode( ap.procedure_name, null, ap.object_name || ap.procedure_name, ap.procedure_name ) routine_name, 
           ao.object_type routine_type,
           decode(impltypeowner, null, to_char(null), SYS_CONTEXT('userenv', 'DB_NAME')) type_udt_catalog,
           to_clob(get_proc_text(ap.owner, ap.object_name, ao.object_type, 32767)) routine_body,
           to_clob(get_proc_text(ap.owner, ap.object_name, ao.object_type, 4000)) routine_definition,
           SYS_CONTEXT('userenv', 'DB_NAME') character_set_catalog,
           'SYS' character_set_schema,
           SYS_CONTEXT('userenv', 'DB_NAME') collation_catalog,
           'SYS' collation_schema,
           deterministic is_deterministic,
           pipelined is_pipelined ,
           aggregate is_aggregate,
           authid is_definer
  FROM all_procedures ap,
       all_objects ao
  WHERE ap.owner = ao.owner
    AND ap.object_name = ao.object_name
    AND ao.object_type in ('PACKAGE', 'PROCEDURE', 'FUNCTION')
) routines
/

grant select on routines to public;

create or replace public synonym routines for information_schema.routines;
